//+-------------------------------------------------------------------------------------+
//|                                                            AMKAandWilder_Expert.mq4 |
//|                                                                           Scriptong |
//|                                                                                     |
//+-------------------------------------------------------------------------------------+
#property copyright "Scriptong"
#property link      "scriptong@mail.ru"

//---- input parameters
extern double    Lots        = 0.1;                          //   
extern int       TakeProfit = 2000;
extern int       StopLoss = 2000;
extern double    TPKoef = 0.9;
extern double    SLKoef = 1.1;
extern int       ResultsPeriod = 11;
extern string    A3 = "  AMKA";
extern int       AMKAPeriod=9;                                             //  AMKA
extern int       FastEMAPeriod=2;                   //     AMKA
extern int       SlowEMAPeriod=30;                  //     AMKA
extern double    PowLevel=2.0;         // ,     AMKA
                                       // 2 -  , 
                                       // 3 -   . .
extern double    dK = 1.0;                                     //   
extern bool      UseStdDev = True;      //    ?
extern int       AMKAPrice = 5;                              //   AMKA (0 - 6)
extern string    A4 = "=====================================";
extern string    OpenOrderSound = "ok.wav";                  //    
extern int       MagicNumber = 17589 ;                         //   
bool Activate, FreeMarginAlert, FatalError;
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep, CurRed, CurBlue;
datetime LastBar;
int TypeOrder, LastType, TicketOrder, Signal;
//   
int Trade = -1,                            //  (-1 - , 0 - BUY, 1 - SELL)
    ProfitSeries = 0,                               //    
    EqualProfits = 0,                               //    
    CountProfits = 0,                                       //   
    LossSeries = 0,                                 //    
    EqualLosses = 0,                                 //    
    CountLosses = 0,                                        //   
    MaxLoss = 0,                               //    
    CurMaxProfit[],       //     ResultsPeriod 
    CurMaxLoss;                                     //    
double OpenPrice = 0,                                     //    
       SLPrice = 0,                                  //  -  
       TPPrice = 0;                                     //    
datetime TimeOrder = 0;                    //     
// --------------------------


//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int init()
  {
//----
   Activate = False;
// - 1 - ==      ========================================
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //  
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                  //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //   
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);    //    
   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);   //    
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);          //    
// - 1 - ==   =============================================================

// - 2 - ==          =======
   Lots = MathRound(Lots/LotStep)*LotStep; //     
   if(Lots < MinLot || Lots > MaxLot) //     MinLot    MaxLot
     {
      Comment(" Lots     !  !");
      return(0);
     }
// - 2 - ==   =============================================================

// - 3 - ==    ==============================================
   CurRed = 0;
   CurBlue = 0;
   Trade = -1; ProfitSeries = 0; EqualProfits = 0; CountProfits = 0; LossSeries = 0;
   EqualLosses = 0; CountLosses = 0; TimeOrder = 0;
   MaxLoss = 0; OpenPrice = 0; SLPrice = 0; TPPrice = 0;
   ArrayResize(CurMaxProfit, ResultsPeriod+1);
   ArrayResize(CurMaxLoss, ResultsPeriod+1);
   
   Comment(",         ");
   for (int i = Bars-MathMax(AMKAPeriod, SlowEMAPeriod); i > 0; i--) 
     {
      GetSignal(i);
      DoTransaction(i-1);       
     }
   Comment(""); 
// - 3 - ==   =============================================================

   LastBar = 0;

   Activate = True; //    ,    
   
//----
   return(0);
  }

//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
//----
   return(0);
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}  
 
//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
 switch(Error)
   {
    case 2: return("  ,   ."); 
    case 5: return("    ,  ."); 
    case 6: return("   ,   ."); 
    case 64: return(" ,   .");
    case 132: return(" ."); 
    case 133: return(" ."); 
    case 149: return(" ."); 
   }
}
  
//+-------------------------------------------------------------------------------------+
//|                                                                      |
//| :                                                                         |
//|   True -                                                       |
//|   False -                                                             |
//+-------------------------------------------------------------------------------------+
bool OpenOrder(int Type, double Price, double SL, double TP)
{
 //     
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lots) <= 0 || GetLastError() == 134) 
  {
   if(!FreeMarginAlert)
    {
     Print("    . Free Margin = ", 
           AccountFreeMargin());
     FreeMarginAlert = True;
    } 
   return(False);  
  }
 FreeMarginAlert = False;  
 // ---------------------------------------------

 switch (Type)
   {
    case OP_BUY: string S = "BUY"; break;
    case OP_SELL: S = "SELL"; break;
    case OP_BUYSTOP: S = "BUYSTOP"; break;
    case OP_SELLSTOP: S = "SELLSTOP"; break;
    case OP_BUYLIMIT: S = "BUYLIMIT"; break;
    case OP_SELLLIMIT: S = "SELLLIMIT"; break;
   }

 if(WaitForTradeContext())  //    
   {  
    Comment("     ", S, " ...");
    int ticket=OrderSend(Symbol(), Type, Lots, Price, 0, 
               SL, TP, NULL, MagicNumber, 0, CLR_NONE);        //  
    //     
    if(ticket<0)
      {
       int Error = GetLastError();
       if(Error == 2 || Error == 5 || Error == 6 || Error == 64 
          || Error == 132 || Error == 133 || Error == 149)     //   
         {
          Comment("     . . "+
                   ErrorToString(Error)+"  !");
          FatalError = True;
         }
        else 
         Comment("   ", S, ": ", Error);       //  
       return(False);
      }
    // ---------------------------------------------
    
    //      
    Comment(" ", S, "  !"); 
    PlaySound(OpenOrderSound); 
    return(True); 
    // ------------------------
   }
  else
   {
    Comment("     !");
    return(False);  
   } 
}

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+
bool WaitForTradeContext()
{
 int P = 0;
 //  ""
 while(IsTradeContextBusy() && P < 5)
   {
    P++;
    Sleep(1000);
   }
 // -------------  
 if(P == 5)
   return(False);
 return(True);    
}

//+-------------------------------------------------------------------------------------+
//|   AMKA  CloseONTheLimit_Reverse                                     |
//+-------------------------------------------------------------------------------------+
void GetSignal(int Bar)
{
 Signal = 0;
// - 1 - ==    AMKA ===================================================
 double RedDot = iCustom(Symbol(), 0, "AMKA", AMKAPeriod, FastEMAPeriod, 
                         SlowEMAPeriod, PowLevel, dK, UseStdDev, AMKAPrice, 1, Bar);
 double BlueDot = iCustom(Symbol(), 0, "AMKA", AMKAPeriod, FastEMAPeriod, 
                          SlowEMAPeriod, PowLevel, dK, UseStdDev, AMKAPrice, 2, Bar);
 if (RedDot != 0 && BlueDot == 0) 
   {
    CurRed = RedDot;
    CurBlue = 0.0;
   } 
 if (BlueDot != 0 && RedDot == 0) 
   {
    CurBlue = BlueDot;
    CurRed = 0.0;
   } 
// - 1 - ==   =============================================================

// - 2 - ==   ==============================================================
  if (CurRed != 0)
    if (ND(Open[Bar]) > ND(Close[Bar]))   //   
      if (ND(Close[Bar]) < ND(Low[Bar+1])) //       
        if (ND(Open[Bar+1]) < ND(Close[Bar+1])) //    
          Signal = 1;
    
  if (CurBlue != 0)
    if (ND(Open[Bar]) < ND(Close[Bar]))   //   
      if (ND(Close[Bar]) > ND(High[Bar+1])) //       
        if (ND(Open[Bar+1]) > ND(Close[Bar+1])) //    
          Signal = 2;
// - 2 - ==   =============================================================
}  

//+-------------------------------------------------------------------------------------+
//|                                                               |
//+-------------------------------------------------------------------------------------+
void ProfitCount()
{
 ProfitSeries++;                                 //     
 EqualProfits++;                        //     
 if (LossSeries > 0)                                //      
   {
    CountLosses++;                                //      1
    LossSeries = 0;       //         
   } 
}

//+-------------------------------------------------------------------------------------+
//|                                                                |
//+-------------------------------------------------------------------------------------+
void LossCount()
{
 LossSeries++;                                   //     
 EqualLosses++;                         //     
 if (ProfitSeries > 0)                             //      
   {
    CountProfits++;                               //      1
    ProfitSeries = 0;    //         
   } 
}

//+-------------------------------------------------------------------------------------+
//|                      |
//+-------------------------------------------------------------------------------------+
void ThrowOld()
{
 for (int i = ResultsPeriod; i > 0; i--)
   CurMaxProfit[i] = CurMaxProfit[i-1];
}

//+-------------------------------------------------------------------------------------+
//|       CurMaxProfit                          |
//+-------------------------------------------------------------------------------------+
int AverageProfit()
{
 double Res = 0;
 for (int i = 1; i < ResultsPeriod+1; i++)
   Res += CurMaxProfit[i];
 return(MathRound(Res/(ResultsPeriod))); 
}


//+-------------------------------------------------------------------------------------+
//|                                                          |
//+-------------------------------------------------------------------------------------+
void DoTransaction(int Bar)
{
// - 1 - ==         =================
    if (Trade != -1)                                      //    
      if (Trade == 0)
        {  //  
         if (ND(Low[Bar+1]) <= SLPrice)                             //  
           {
            Trade = -1;                                   //   
            LossCount();
           }
          else 
           if (ND(High[Bar+1]) >= TPPrice)                        //  
             {
              Trade = -1;                                 //   
              ProfitCount();
             }
         CurMaxProfit[0] = MathMax(CurMaxProfit[0], (High[Bar+1] - OpenPrice)/Point);    
         CurMaxLoss = MathMax(CurMaxLoss, (OpenPrice - Low[Bar+1])/Point);    
        }
       else
        { //  
         if (ND(High[Bar+1]+Spread) >= SLPrice)                     //  
           {
            Trade = -1;                                   //   
            LossCount();
           }
          else 
           if (ND(Low[Bar+1]+Spread) <= TPPrice)                  //  
             {
              Trade = -1;                                 //   
              ProfitCount();
             }
         CurMaxProfit[0] = MathMax(CurMaxProfit[0], (OpenPrice - Low[Bar+1] - Spread)/Point);    
         CurMaxLoss = MathMax(CurMaxLoss, (High[Bar+1] + Spread - OpenPrice)/Point);    
        }    
// - 1 -  ==   ============================================================

// - 2 - ==        ========================
    if (Signal == 1 && Trade != 0)
     {
      double Price = ND(Open[Bar]+Spread);
      if (Trade == 1)                                 //  ,  
        {
         if (OpenPrice-Price >= 0)
           ProfitCount();
          else
           LossCount();
         MaxLoss = MathMax(CurMaxLoss, MaxLoss); 
        }
      Trade = 0;                                              //   
      TimeOrder = Time[Bar];
      OpenPrice = Price;                                          //   
      TPPrice = ND(Price + TakeProfit*Tick);                             //  
      SLPrice = ND(Price - StopLoss*Tick);                                 //  
      ThrowOld();
      CurMaxProfit[0] = -(Spread/Point);//      
      CurMaxLoss = Spread/Point;              //     
     }
// - 2 -  ==   ============================================================
     
// - 3 - ==        ========================
    if (Signal == 2 && Trade != 1)
     {
      Price = ND(Open[Bar]);
      if (Trade == 0)                                  //  ,  
        {
         if (Price-OpenPrice-Spread >= 0)
           ProfitCount();
          else
           LossCount();
         MaxLoss = MathMax(CurMaxLoss, MaxLoss);  
        }
      Trade = 1;                                             //   
      TimeOrder = Time[Bar];
      OpenPrice = Price;                                          //   
      TPPrice = ND(Price - TakeProfit*Tick);                             //  
      SLPrice = ND(Price + StopLoss*Tick);                                 //  
      ThrowOld();
      CurMaxProfit[0] = -(Spread/Point);//      
      CurMaxLoss = Spread/Point;              //     
     }
// - 3 -  ==   ============================================================
}

//+-------------------------------------------------------------------------------------+
//|     Type.     ,  1.             |
//|   ,   2.    0.              |
//+-------------------------------------------------------------------------------------+
int CheckOrdersReal(int Type)
{
 for (int i = OrdersTotal()-1; i >= 0; i--)
   if(OrderSelect(i, SELECT_BY_POS))
     if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber 
        && OrderType() < 2)                                       //  "" 
       if(OrderType() == Type)                                  //    Type
         {
          if (WaitForTradeContext())  
            {
             if(Type == OP_BUY)
               double Pr = ND(MarketInfo(Symbol(), MODE_BID));
              else
               Pr = ND(MarketInfo(Symbol(), MODE_ASK));
             if (!OrderClose(OrderTicket(), OrderLots(), Pr, 3))//    
              return(1);                                 //    -  1
            }  
           else
            return(1);// 1,       
         }
        else
         return(2);          //  2,   ,  
 return(0);                                                   //   ,   0
}  

//+-------------------------------------------------------------------------------------+
//|    "if-else"                                                 |
//+-------------------------------------------------------------------------------------+
double IF(bool Condition, double IfTrue, double IfFalse)
{
 if (Condition) return(IfTrue);    //   ,    IfTrue
 else           return(IfFalse);    //   ,    IfFalse
}  

//+-------------------------------------------------------------------------------------+
//|  START                                                               |
//+-------------------------------------------------------------------------------------+
int start()
  {
// - 1 -  ==    ? ===========================================
   if (!Activate || FatalError)             //   ,  
    return(0);           //  init         
// - 1 -  ==   ============================================================

// - 2 -  ==     ==============================================
   if (LastBar == Time[0])                        //      
     return(0);                                                         //  
// - 2 -  ==   ============================================================

// - 3 - ==      ========================================
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                  //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //   
// - 3 -  ==   ============================================================
     
// - 4 - ==    =====================================================
   GetSignal(1);                                                       //   
   DoTransaction(0);                                                //  
   if (CountProfits == 0)                       //    
      int PC = EqualProfits;
    else
     PC = MathRound((EqualProfits/1.0)/CountProfits);         //   
   if (CountLosses == 0)                        //    
     int LC = EqualLosses;
    else
     LC = MathRound((EqualLosses/1.0)/CountLosses);          //   
     
   Comment("    ", PC, 
           "\n    ", LC,
           "\n -    ", ProfitSeries,
           "\n -    ", LossSeries, 
           "\n   ", MaxLoss,
           "\n    ", 
           AverageProfit());
// - 4 -  ==   ============================================================
   
   double Price = 0;
   int Type = -1;
   
// - 6 - ==    ====================================================
   if (Signal == 1 && TimeOrder == Time[0])
     {
      int Res = CheckOrdersReal(OP_SELL);
      RefreshRates();
      if (Res == 0)                                          //    
        {                                               
         Price = ND(Ask);
         if (LossSeries > 0)
           {
            int NewTP = MathRound(TPKoef*AverageProfit());
            int NewSL = SLKoef*MaxLoss;
           } 
          else
           {
            NewTP = ArrayMinimum(CurMaxProfit, ResultsPeriod, 1);
            NewSL = NewTP+2*(Spread/Point);
           } 
         double TP = ND(IF(NewTP > StopLevel/Point, Price+NewTP*Tick,
                           Price + StopLevel));
         double SL = ND(IF(NewSL > (StopLevel+Spread)/Point, Price-NewSL*Tick,
                           Price - StopLevel-Spread));
         Type = OP_BUY;
        }                    
      if (Res == 1) return(0);                      //    
     }
// - 6 -  ==   ============================================================
     
// - 7 - ==   SellStop ===================================================
   if (Signal == 2 && TimeOrder == Time[0])
     {
      Res = CheckOrdersReal(OP_BUY);
      if (Res == 0)                                          //    
        {               
         RefreshRates();
         Price = ND(Bid);
         if (LossSeries > 0)
           {
            NewTP = MathRound(TPKoef*AverageProfit());
            NewSL = SLKoef*MaxLoss;
           } 
          else
           {
            NewTP = ArrayMinimum(CurMaxProfit, ResultsPeriod, 1);
            NewSL = NewTP+2*(Spread/Point);
           } 
         TP = ND(IF(NewTP > StopLevel/Point, Price-NewTP*Tick, 
                    Price - StopLevel));
         SL = ND(IF(NewSL > (StopLevel+Spread)/Point, Price+NewSL*Tick,
                    Price + StopLevel + Spread));
         Type = OP_SELL;
        }                    
      if (Res == 1) return(0);                      //    
     }
// - 7 -  ==   ============================================================

   if (Type >= 0)
     if (!OpenOrder(Type, Price, SL, TP))             //     
        return(0);                                     //     
        
   LastBar = Time[0];     

   return(0);
  }
//+------------------------------------------------------------------+